Index: trunk/anuga_core/source/anuga/shallow_water/okada_tsunami.py
===================================================================
--- trunk/anuga_core/source/anuga/shallow_water/okada_tsunami.py	(revision 8546)
+++ trunk/anuga_core/source/anuga/shallow_water/okada_tsunami.py	(revision 8548)
@@ -23,5 +23,14 @@
 """
 import numpy
-import okada_tsunami_fortran
+
+try:
+    import okada_tsunami_fortran
+except:
+    raise Exception,\
+    'okada_tsunami_fortran does not appear to be compiled.\n \
+    You can compile it by running the command:\n \
+    "f2py -c okada_tsunami_fortran.f -m okada_tsunami_fortran"\n \
+    in the shallow_water directory'
+ 
 from pyproj import Proj
 import copy
Index: trunk/anuga_core/validation_tests/Tests/Benchmarks/Isolated_Building/results.tex
===================================================================
--- trunk/anuga_core/validation_tests/Tests/Benchmarks/Isolated_Building/results.tex	(revision 8546)
+++ trunk/anuga_core/validation_tests/Tests/Benchmarks/Isolated_Building/results.tex	(revision 8548)
@@ -3,10 +3,18 @@
 
 Herein \anuga{} is tested against the isolated obstacle test, which involves a dam-break flow past an isolated building. This benchmark experiment is reported in:
-
-Soares-Frazao, S. and Zech, Y. (2007) Experimental study of dam-break flow against an isolated obstacle. Journal of Hydraulic Resaerch 45(Extra Issue):27-36
+\begin{verbatim}
+Soares-Frazao, S. and Zech, Y. (2007)
+Experimental study of dam-break flow against an isolated obstacle. Journal of
+Hydraulic Resaerch 45(Extra Issue):27-36
+\end{verbatim}
 
 The data is provided in a DVD-ROM associated with the above JHR issue.
 
-Note that many models have been applied to this problem, and their performance is reviewed in Soares Frazao, S., Noel, B., Spinewine, B., and Zech, Y. (YEAR) The isolated building test case: results from the IMPACT benchmark. At the time of writing, the performance of \anuga{} on this problem is qualitatively similar to the performance of most other models -- i.e. it simulates the main aspects of the flow, but often not the details. It seems likely that these experimental flows may well partly violate the shallow water approximations, and to the extent that this is true, we would not expect perfect agreement.
+Note that many models have been applied to this problem, and their performance is reviewed in:
+\begin{verbatim}
+ Soares Frazao, S., Noel, B., Spinewine, B., and Zech, Y. (YEAR) The isolated
+building test case: results from the IMPACT benchmark.
+\end{verbatim}
+ At the time of writing, the performance of \anuga{} on this problem is qualitatively similar to the performance of most other models -- i.e. it simulates the main aspects of the flow, but often not the details. It seems likely that these experimental flows may well partly violate the shallow water approximations, and to the extent that this is true, we would not expect perfect agreement.
 
 \subsection{Results}
Index: trunk/anuga_core/validation_tests/Tests/Simple/parabolic_basin_1D/parabolic.py
===================================================================
--- trunk/anuga_core/validation_tests/Tests/Simple/parabolic_basin_1D/parabolic.py	(revision 8546)
+++ trunk/anuga_core/validation_tests/Tests/Simple/parabolic_basin_1D/parabolic.py	(revision 8548)
@@ -15,5 +15,5 @@
 domain.set_name('parabola_v2')                         # Output to file runup.sww
 domain.set_datadir('.')                          # Use current folder
-domain.set_minimum_allowed_height(0.01)
+#domain.set_minimum_allowed_height(0.01)
 
 
Index: trunk/anuga_core/validation_tests/Tests/Simple/runup_sinusoid/runup_sinusoid.py
===================================================================
--- trunk/anuga_core/validation_tests/Tests/Simple/runup_sinusoid/runup_sinusoid.py	(revision 8546)
+++ trunk/anuga_core/validation_tests/Tests/Simple/runup_sinusoid/runup_sinusoid.py	(revision 8548)
@@ -25,5 +25,5 @@
 domain.set_quantities_to_be_stored({'stage': 2, 'xmomentum': 2, 'ymomentum': 2, 'elevation': 1})
 #domain.set_store_vertices_uniquely(True)
-domain.minimum_allowed_height=0.001
+#domain.minimum_allowed_height=0.001
 
 #------------------------------------------------------------------------------
Index: trunk/anuga_core/validation_tests/__init__.py
===================================================================
--- trunk/anuga_core/validation_tests/__init__.py	(revision 8546)
+++ trunk/anuga_core/validation_tests/__init__.py	(revision 8548)
@@ -1,8 +1,4 @@
 """
-    A set of modules which is used to build a geometrical representation
-    of the test scenario domain.
-    
-    It contains functions for fitting data across an arbitrary terrain height
-    mesh. 
+    Validation tests
 """
 
@@ -12,3 +8,2 @@
 
 
-
Index: trunk/anuga_core/validation_tests/produce_results.py
===================================================================
--- trunk/anuga_core/validation_tests/produce_results.py	(revision 8546)
+++ trunk/anuga_core/validation_tests/produce_results.py	(revision 8548)
@@ -20,5 +20,14 @@
 timestamp = time.asctime()
 major_revision = anuga.config.major_revision
-minor_revision = anuga.utilities.system_tools.get_revision_number()
+try:
+    # This fails if using git for version control
+    minor_revision = anuga.utilities.system_tools.get_revision_number()
+except:
+    try:
+        # This works when using git on unix
+        minor_revision=os.popen("git show-ref --head -s | head -n1").read().strip()
+    except:
+        # This is a fallback position
+        minor_revision='unknown'
 
 #---------------------------------
Index: trunk/anuga_core/validation_tests/report.tex
===================================================================
--- trunk/anuga_core/validation_tests/report.tex	(revision 8546)
+++ trunk/anuga_core/validation_tests/report.tex	(revision 8548)
@@ -50,5 +50,5 @@
 %======================
 
-%\inputresults{Tests/Benchmarks/Isolated_Building}
+\inputresults{Tests/Benchmarks/Isolated_Building}
 
 \inputresults{Tests/Benchmarks/Okushiri}